Index: trunk/testdata/blog/.test/about.html
===================================================================
--- trunk/testdata/blog/.test/about.html	(revision 22)
+++ trunk/testdata/blog/.test/about.html	(revision 22)
@@ -0,0 +1,10 @@
+<html>
+	<head>
+		<title>About myself</title>
+		<link href="styles.css" rel="stylesheet" type="text/css" />
+	</head>
+	<body><h1>About myself</h1>
+
+<p>Hi all. This is a brief description of who I am.</p>
+</body>
+</html>
Index: trunk/testdata/blog/.test/index.html
===================================================================
--- trunk/testdata/blog/.test/index.html	(revision 22)
+++ trunk/testdata/blog/.test/index.html	(revision 22)
@@ -0,0 +1,17 @@
+<html>
+	<head>
+		<title>My blog</title>
+		<link href="styles.css" rel="stylesheet" type="text/css" />
+	</head>
+	<body>
+		<p>Here goes list of posts</p>
+		<ul>
+			<li>
+				<a href="/posts/hello.html">First post</a>
+			</li>
+			<li>
+				<a href="/posts/update.html">Second post</a>
+			</li>
+		</ul>
+	</body>
+</html>
Index: trunk/testdata/blog/.test/posts/hello.html
===================================================================
--- trunk/testdata/blog/.test/posts/hello.html	(revision 22)
+++ trunk/testdata/blog/.test/posts/hello.html	(revision 22)
@@ -0,0 +1,10 @@
+<html>
+	<head>
+		<title>First post</title>
+		<link href="styles.css" rel="stylesheet" type="text/css" />
+	</head>
+	<body><h1>First post</h1>
+
+<p>This is my first post</p>
+</body>
+</html>
Index: trunk/testdata/blog/.test/posts/update.html
===================================================================
--- trunk/testdata/blog/.test/posts/update.html	(revision 22)
+++ trunk/testdata/blog/.test/posts/update.html	(revision 22)
@@ -0,0 +1,10 @@
+<html>
+	<head>
+		<title>Second post</title>
+		<link href="styles.css" rel="stylesheet" type="text/css" />
+	</head>
+	<body><h1>Second post</h1>
+
+<p>This is my second post</p>
+</body>
+</html>
Index: trunk/testdata/blog/.test/styles.css
===================================================================
--- trunk/testdata/blog/.test/styles.css	(revision 22)
+++ trunk/testdata/blog/.test/styles.css	(revision 22)
@@ -0,0 +1,1 @@
+html{margin:0;padding:0;box-sizing:border-box;}body{font-size:16pt;}
Index: trunk/testdata/blog/.zs/layout.amber
===================================================================
--- trunk/testdata/blog/.zs/layout.amber	(revision 22)
+++ trunk/testdata/blog/.zs/layout.amber	(revision 22)
@@ -0,0 +1,6 @@
+html
+	head
+		title #{title}
+		link[href="styles.css"][rel="stylesheet"][type="text/css"]
+	body
+		#{unescaped(content)}
Index: trunk/testdata/blog/about.md
===================================================================
--- trunk/testdata/blog/about.md	(revision 22)
+++ trunk/testdata/blog/about.md	(revision 22)
@@ -0,0 +1,6 @@
+title: About myself
+date: 28-08-2015
+
+# {{title}}
+
+Hi all. This is a brief description of who I am.
Index: trunk/testdata/blog/index.amber
===================================================================
--- trunk/testdata/blog/index.amber	(revision 22)
+++ trunk/testdata/blog/index.amber	(revision 22)
@@ -0,0 +1,12 @@
+html
+	head
+		title My blog
+		link[href="styles.css"][rel="stylesheet"][type="text/css"]
+	body
+		p Here goes list of posts
+		ul
+			li
+				a[href="/posts/hello.html"] First post
+			li
+				a[href="/posts/update.html"] Second post
+
Index: trunk/testdata/blog/posts/hello.md
===================================================================
--- trunk/testdata/blog/posts/hello.md	(revision 22)
+++ trunk/testdata/blog/posts/hello.md	(revision 22)
@@ -0,0 +1,7 @@
+title: First post
+date: 28-08-2015
+
+# {{title}}
+
+This is my first post
+
Index: trunk/testdata/blog/posts/update.md
===================================================================
--- trunk/testdata/blog/posts/update.md	(revision 22)
+++ trunk/testdata/blog/posts/update.md	(revision 22)
@@ -0,0 +1,7 @@
+title: Second post
+date: 29-08-2015
+
+# {{title}}
+
+This is my second post
+
Index: trunk/testdata/blog/styles.gcss
===================================================================
--- trunk/testdata/blog/styles.gcss	(revision 22)
+++ trunk/testdata/blog/styles.gcss	(revision 22)
@@ -0,0 +1,7 @@
+html
+  margin: 0
+  padding: 0
+  box-sizing: border-box
+
+body
+  font-size: 16pt