Index: trunk/testdata/blog/.test/about.html
===================================================================
--- trunk/testdata/blog/.test/about.html	(revision 35)
+++ 	(revision )
@@ -1,10 +1,0 @@
-<html>
-	<head>
-		<title>About myself</title>
-		<link href="styles.css" rel="stylesheet" type="text/css" />
-	</head>
-	<body><h1>About myself</h1>
-
-<p>Hi all. This is a brief description of who I am.</p>
-</body>
-</html>
Index: trunk/testdata/blog/.test/index.html
===================================================================
--- trunk/testdata/blog/.test/index.html	(revision 35)
+++ 	(revision )
@@ -1,17 +1,0 @@
-<html>
-	<head>
-		<title>My blog</title>
-		<link href="styles.css" rel="stylesheet" type="text/css" />
-	</head>
-	<body>
-		<p>Here goes list of posts</p>
-		<ul>
-			<li>
-				<a href="/posts/hello.html">First post</a>
-			</li>
-			<li>
-				<a href="/posts/update.html">Second post</a>
-			</li>
-		</ul>
-	</body>
-</html>
Index: trunk/testdata/blog/.test/posts/hello.html
===================================================================
--- trunk/testdata/blog/.test/posts/hello.html	(revision 35)
+++ 	(revision )
@@ -1,10 +1,0 @@
-<html>
-	<head>
-		<title>First post</title>
-		<link href="styles.css" rel="stylesheet" type="text/css" />
-	</head>
-	<body><h1>First post</h1>
-
-<p>This is my first post</p>
-</body>
-</html>
Index: trunk/testdata/blog/.test/posts/update.html
===================================================================
--- trunk/testdata/blog/.test/posts/update.html	(revision 35)
+++ 	(revision )
@@ -1,10 +1,0 @@
-<html>
-	<head>
-		<title>Second post</title>
-		<link href="styles.css" rel="stylesheet" type="text/css" />
-	</head>
-	<body><h1>Second post</h1>
-
-<p>This is my second post</p>
-</body>
-</html>
Index: trunk/testdata/blog/.test/styles.css
===================================================================
--- trunk/testdata/blog/.test/styles.css	(revision 35)
+++ 	(revision )
@@ -1,1 +1,0 @@
-html{margin:0;padding:0;box-sizing:border-box;}body{font-size:16pt;}
Index: trunk/testdata/blog/.zs/layout.amber
===================================================================
--- trunk/testdata/blog/.zs/layout.amber	(revision 35)
+++ 	(revision )
@@ -1,6 +1,0 @@
-html
-	head
-		title #{title}
-		link[href="styles.css"][rel="stylesheet"][type="text/css"]
-	body
-		#{unescaped(content)}
Index: trunk/testdata/blog/about.md
===================================================================
--- trunk/testdata/blog/about.md	(revision 35)
+++ 	(revision )
@@ -1,7 +1,0 @@
-title: About myself
-date: 28-08-2015
----
-
-# {{title}}
-
-Hi all. This is a brief description of who I am.
Index: trunk/testdata/blog/index.amber
===================================================================
--- trunk/testdata/blog/index.amber	(revision 35)
+++ 	(revision )
@@ -1,12 +1,0 @@
-html
-	head
-		title My blog
-		link[href="styles.css"][rel="stylesheet"][type="text/css"]
-	body
-		p Here goes list of posts
-		ul
-			li
-				a[href="/posts/hello.html"] First post
-			li
-				a[href="/posts/update.html"] Second post
-
Index: trunk/testdata/blog/posts/hello.md
===================================================================
--- trunk/testdata/blog/posts/hello.md	(revision 35)
+++ 	(revision )
@@ -1,8 +1,0 @@
-title: First post
-date: 28-08-2015
----
-
-# {{title}}
-
-This is my first post
-
Index: trunk/testdata/blog/posts/update.md
===================================================================
--- trunk/testdata/blog/posts/update.md	(revision 35)
+++ 	(revision )
@@ -1,8 +1,0 @@
-title: Second post
-date: 29-08-2015
----
-
-# {{title}}
-
-This is my second post
-
Index: trunk/testdata/blog/styles.gcss
===================================================================
--- trunk/testdata/blog/styles.gcss	(revision 35)
+++ 	(revision )
@@ -1,7 +1,0 @@
-html
-  margin: 0
-  padding: 0
-  box-sizing: border-box
-
-body
-  font-size: 16pt
Index: trunk/testdata/page/.test/index.html
===================================================================
--- trunk/testdata/page/.test/index.html	(revision 35)
+++ 	(revision )
@@ -1,5 +1,0 @@
-<html>
-	<body>
-		<h1>Hello</h1>
-	</body>
-</html>
Index: trunk/testdata/page/index.html
===================================================================
--- trunk/testdata/page/index.html	(revision 35)
+++ 	(revision )
@@ -1,5 +1,0 @@
-<html>
-	<body>
-		<h1>{{ printf Hello }}</h1>
-	</body>
-</html>
Index: trunk/testdata/sugar/.test/index.html
===================================================================
--- trunk/testdata/sugar/.test/index.html	(revision 35)
+++ 	(revision )
@@ -1,5 +1,0 @@
-<html>
-	<body>
-		<p>Hello world</p>
-	</body>
-</html>
Index: trunk/testdata/sugar/.test/styles.css
===================================================================
--- trunk/testdata/sugar/.test/styles.css	(revision 35)
+++ 	(revision )
@@ -1,1 +1,0 @@
-body{font:100% Helvetica, sans-serif;color:blue;}
Index: trunk/testdata/sugar/index.amber
===================================================================
--- trunk/testdata/sugar/index.amber	(revision 35)
+++ 	(revision )
@@ -1,3 +1,0 @@
-html
-	body
-		p Hello world
Index: trunk/testdata/sugar/styles.gcss
===================================================================
--- trunk/testdata/sugar/styles.gcss	(revision 35)
+++ 	(revision )
@@ -1,6 +1,0 @@
-$base-font: Helvetica, sans-serif
-$main-color: blue
-
-body
-  font: 100% $base-font
-  color: $main-color